@webUI @insulated @disablePreviews @activity-app-required
Feature: activities with firewall app enabled
  The firewall should not change the behaviour of the activity app

  Background:
    Given the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "mime-limiter"
    And the user has placed a rule with the filter "File mimetype upload", the operator "is" and the value "text/plain" in the group named "mime-limiter"
    And the user has saved the firewall rules

  Scenario Outline: a not blocked upload is listed in the activities
    Given using <dav-path-version> DAV path
    And the user has uploaded file "filesForUpload/data.zip" to "/upload.zip"
    And the user has uploaded file "filesForUpload/new-data.zip" to "/upload.zip"
    When the user browses to the activity page
    Then the activity number 1 should have message "You changed upload.zip" in the activity page
    And the activity number 2 should contain message "You created upload.zip" in the activity page
    Examples:
      | dav-path-version |
      | old              |
      | new              |

  Scenario Outline: a blocked upload is not listed in the activities
    Given using <dav-path-version> DAV path
    When the user uploads file "filesForUpload/lorem.txt" to "/upload.txt" using the WebDAV API
    And the user uploads file "filesForUpload/new-lorem.txt" to "/upload.txt" using the WebDAV API
    And the user browses to the activity page
    Then the activity should not have any message with keyword "upload.txt"
    Examples:
      | dav-path-version |
      | old              |
      | new              |
