@webUI
Feature: LimitFileAccessBasedOnGroups

  Background:
    Given these users have been created with skeleton files:
      | username |
      | Alice    |
      | Brian    |
    And these groups have been created:
      | groupname |
      | test-grp1 |
    And user "Alice" has been added to group "test-grp1"
    And the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "group-limiter"

  Scenario: prohibit file access for a specific user group
    When the user places a rule with the filter "User Group", the operator "is" and the value "test-grp1" in the group named "group-limiter"
    And the user saves the firewall rules
    Then it should not be possible for user "Alice" to download the file "data.zip" using "any" dav path
    But it should be possible for user "Brian" to download the file "data.zip" using "any" dav path

  Scenario: prohibit file access for everybody except a specific user group
    When the user places a rule with the filter "User Group", the operator "is not" and the value "test-grp1" in the group named "group-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "data.zip" using "any" dav path
    But it should not be possible for user "Brian" to download the file "data.zip" using "any" dav path

  Scenario: prohibit file access for a specific user group and check the previews
    When the user places a rule with the filter "User Group", the operator "is" and the value "test-grp1" in the group named "group-limiter"
    And the user saves the firewall rules
    Then it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    But it should be possible for user "Brian" to view the preview of "testimage.jpg"

  Scenario: prohibit file access for everybody except a specific user group and check the previews
    When the user places a rule with the filter "User Group", the operator "is not" and the value "test-grp1" in the group named "group-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to view the preview of "testimage.jpg"
    But it should not be possible for user "Brian" to view the preview of "testimage.jpg"
