@webUI @skipWhenTestingRemoteSystems
Feature: LimitFileAccessBasedOnIpv6Subnet

  Background:
    Given the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "ipsubnet-limiter"
    And these users have been created with skeleton files:
      | username |
      | Alice    |
    And user "Alice" has created a public link share of file "testimage.gif"

  @skip @ipv6
  Scenario: prohibit file access from inside a specified IPv6 subnet
    Given the user has placed a rule with the filter "Client IP Subnet (IPv6)", the operator "is", for a routable "IPv6" address subnet and the CIDR "64" in the group named "ipsubnet-limiter"
    And the user has saved the firewall rules
    When the client accesses the server from a loopback "IPv6" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a routable "IPv6" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv4" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a routable "IPv4" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link

  @skip @ipv6
  Scenario: prohibit file access from inside a specified IPv4 subnet
    Given the user has placed a rule with the filter "Client IP Subnet (IPv4)", the operator "is", for a routable "IPv4" address subnet and the CIDR "24" in the group named "ipsubnet-limiter"
    And the user has saved the firewall rules
    When the client accesses the server from a loopback "IPv4" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a routable "IPv4" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv6" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a routable "IPv6" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link

  @skip @ipv6
  Scenario: prohibit file access from outside a specified IPv6 subnet
    Given the user has placed a rule with the filter "Client IP Subnet (IPv6)", the operator "is not", for a routable "IPv6" address subnet and the CIDR "64" in the group named "ipsubnet-limiter"
    And the user has saved the firewall rules
    When the client accesses the server from a routable "IPv6" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv6" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a routable "IPv4" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv4" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link

  @skip @ipv6
  Scenario: prohibit file access from outside a specified IPv4 subnet
    Given the user has placed a rule with the filter "Client IP Subnet (IPv4)", the operator "is not", for a routable "IPv4" address subnet and the CIDR "24" in the group named "ipsubnet-limiter"
    And the user has saved the firewall rules
    When the client accesses the server from a routable "IPv4" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv4" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a routable "IPv6" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv6" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link

  @skip @ipv6
  Scenario: prohibit file access from outside a specified IPv6 and IPv4 subnet
    Given the user has placed a rule with the filter "Client IP Subnet (IPv6)", the operator "is not", for a routable "IPv6" address subnet and the CIDR "64" in the group named "ipsubnet-limiter"
    And the user has placed a rule with the filter "Client IP Subnet (IPv4)", the operator "is not", for a routable "IPv4" address subnet and the CIDR "24" in the group named "ipsubnet-limiter"
    And the user has saved the firewall rules
    When the client accesses the server from a routable "IPv6" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv6" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a routable "IPv4" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv4" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link

  @skip @ipv6
  Scenario: prohibit file access from inside the loopback IPv6 subnet
    Given the user has placed a rule with the filter "Client IP Subnet (IPv6)", the operator "is", for the loopback "IPv6" address subnet and the CIDR "128" in the group named "ipsubnet-limiter"
    And the user has saved the firewall rules
    When the client accesses the server from a routable "IPv6" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv6" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a routable "IPv4" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv4" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link

  @skip @ipv6
  Scenario: prohibit file access from inside the loopback IPv4 subnet
    Given the user has placed a rule with the filter "Client IP Subnet (IPv4)", the operator "is", for the loopback "IPv4" address subnet and the CIDR "8" in the group named "ipsubnet-limiter"
    And the user has saved the firewall rules
    When the client accesses the server from a routable "IPv6" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv6" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a routable "IPv4" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv4" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link

  @skip @ipv6
  Scenario: prohibit file access from outside the loopback IPv6 subnet
    Given the user has placed a rule with the filter "Client IP Subnet (IPv6)", the operator "is not", for the loopback "IPv6" address subnet and the CIDR "128" in the group named "ipsubnet-limiter"
    And the user has saved the firewall rules
    When the client accesses the server from a routable "IPv6" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv6" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a routable "IPv4" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv4" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link

  @skip @ipv6
  Scenario: prohibit file access from outside the loopback IPv4 subnet
    Given the user has placed a rule with the filter "Client IP Subnet (IPv4)", the operator "is not", for the loopback "IPv4" address subnet and the CIDR "24" in the group named "ipsubnet-limiter"
    And the user has saved the firewall rules
    When the client accesses the server from a routable "IPv4" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv4" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a routable "IPv6" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv6" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link

  @skip @ipv6
  Scenario: prohibit file access from outside the loopback IPv6 and IPv4 subnet
    Given the user has placed a rule with the filter "Client IP Subnet (IPv6)", the operator "is not", for the loopback "IPv6" address subnet and the CIDR "128" in the group named "ipsubnet-limiter"
    And the user has placed a rule with the filter "Client IP Subnet (IPv4)", the operator "is not", for the loopback "IPv4" address subnet and the CIDR "8" in the group named "ipsubnet-limiter"
    And the user has saved the firewall rules
    When the client accesses the server from a loopback "IPv6" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a routable "IPv6" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a loopback "IPv4" address
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should be possible to view the preview of "testimage.gif" through the last created public link
    When the client accesses the server from a routable "IPv4" address
    Then it should not be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "testimage.jpg"
    And it should not be possible to view the preview of "testimage.gif" through the last created public link
