@webUI
Feature: LimitFileAccessBasedOnRegExGroups

  Background:
    Given these users have been created with skeleton files:
      | username | password |
      | Alice    | 654321   |
      | Brian    | abcdefg  |
    And these groups have been created:
      | groupname |
      | abc1      |
      | test-grp  |
    And user "Alice" has been added to group "abc1"
    And user "Brian" has been added to group "test-grp"
    And the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "group-limiter"

  Scenario: prohibit file access for user group matching a regular expression
    When the user places a regular expression rule with the filter "User Group", the operator "is" and the value "[a-z]{3}\d" in the group named "group-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Brian" to download the file "data.zip" using "any" dav path
    But it should not be possible for user "Alice" to download the file "data.zip" using "any" dav path

  Scenario: prohibit file access for all groups not matching a regular expression
    When the user places a regular expression rule with the filter "User Group", the operator "is not" and the value "[a-z]{3}\d" in the group named "group-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "data.zip" using "any" dav path
    But it should not be possible for user "Brian" to download the file "data.zip" using "any" dav path

  Scenario: prohibit file access for user group matching a regular expression
    When the user places a regular expression rule with the filter "User Group", the operator "is" and the value "[a-z]{3}\d" in the group named "group-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Brian" to view the preview of "testimage.jpg"
    But it should not be possible for user "Alice" to view the preview of "testimage.jpg"

  Scenario: prohibit file access for all groups not matching a regular expression
    When the user places a regular expression rule with the filter "User Group", the operator "is not" and the value "[a-z]{3}\d" in the group named "group-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to view the preview of "testimage.jpg"
    But it should not be possible for user "Brian" to view the preview of "testimage.jpg"
