@webUI
Feature: LimitFileAccessBasedOnRegExUserAgent

  Background:
    Given the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "regex-limiter"
    And these users have been created with skeleton files:
      | username |
      | Alice    |
    And user "Alice" has created a public link share of file "testimage.gif"

  Scenario: prohibit file access for User Agents matching a simple regular expression
    When the user places a regular expression rule with the filter "User Agent", the operator "is" and the value "Windows" in the group named "regex-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "lorem.txt" with the "Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/53.0" user agent using "any" dav path
    But it should not be possible for user "Alice" to download the file "lorem.txt" with the "Mozilla/5.0 (Windows NT 10.0; WOW64) Gecko/20100101 Firefox/53.0" user agent using "any" dav path
    And it should not be possible to upload a file with the "Mozilla/5.0 (Windows NT 10.0; WOW64) Gecko/20100101 Firefox/53.0" user agent using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "lorem.txt" with the "Mozilla/5.0 (Windows NT 10.0; WOW64) Gecko/20100101 Firefox/53.0" user agent
    And it should not be possible to view the preview of "testimage.gif" through the last created public link with the "Mozilla/5.0 (Windows NT 10.0; WOW64) Gecko/20100101 Firefox/53.0" user agent
    And it should not be possible to download the file "testimage.gif" through the last created public link with the "Mozilla/5.0 (Windows NT 10.0; WOW64) Gecko/20100101 Firefox/53.0" user agent
    And it should be possible to view the preview of "testimage.gif" through the last created public link with the "Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/53.0" user agent
    And it should be possible to download the file "testimage.gif" through the last created public link with the "Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/53.0" user agent

  Scenario: prohibit file access for User Agents not matching a simple regular expression
    When the user places a regular expression rule with the filter "User Agent", the operator "is not" and the value "Linux" in the group named "regex-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "lorem.txt" with the "Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/53.0" user agent using "any" dav path
    But it should not be possible for user "Alice" to download the file "lorem.txt" with the "Mozilla/5.0 (Windows NT 10.0; WOW64) Gecko/20100101 Firefox/53.0" user agent using "any" dav path
    And it should not be possible to upload a file with the "Mozilla/5.0 (Windows NT 10.0; WOW64) Gecko/20100101 Firefox/53.0" user agent using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "lorem.txt" with the "Mozilla/5.0 (Windows NT 10.0; WOW64) Gecko/20100101 Firefox/53.0" user agent
    And it should not be possible to view the preview of "lorem.txt" through the last created public link with the "Mozilla/5.0 (Windows NT 10.0; WOW64) Gecko/20100101 Firefox/53.0" user agent
