<?php
/**
 * ownCloud Workflow
 *
 * @author Joas Schilling <nickvergessen@owncloud.com>
 * @copyright 2015 ownCloud, Inc.
 *
 * This code is covered by the ownCloud Commercial License.
 *
 * You should have received a copy of the ownCloud Commercial License
 * along with this program. If not, see <https://owncloud.com/licenses/owncloud-commercial/>.
 *
 */

namespace OCA\Workflow\Tests\Unit\Mock;

use OCA\Workflow\Condition\Rules\BaseRule;

/**
 * Class NoAbstractRule
 *
 * PHP Fatal error:  Class Mock_BaseRule_fee4c310 contains 1 abstract method and
 * must therefore be declared abstract or implement the remaining methods
 *
 * @package OCA\Workflow\Tests\Mock
 */
class NoAbstractRule extends BaseRule {

	/**
	 * Return an array with the allowed operators
	 *
	 * @return string[]
	 */
	protected function getValidOperators() {
		return [];
	}

	/**
	 * @param mixed $ruleValue
	 * @param string $ruleId
	 * @throws \OutOfBoundsException when the value is not allowed
	 */
	public function validateRuleValue($ruleValue, $ruleId) {
	}

	/**
	 * Return whether the request passes the check or not
	 *
	 * @param string $operator
	 * @param mixed $ruleValue
	 * @return boolean True if the check passes, false if the check fails
	 */
	public function doCheck($operator, $ruleValue) {
		return true;
	}
}
